Package org.optaplanner.core.impl.score.buildin.simplebigdecimal

## Class SimpleBigDecimalScoreHolderImpl

- java.lang.Object
- - org.optaplanner.core.impl.score.holder.AbstractScoreHolder<SimpleBigDecimalScore>
  - - org.optaplanner.core.impl.score.buildin.simplebigdecimal.SimpleBigDecimalScoreHolderImpl

- All Implemented Interfaces:
    `SimpleBigDecimalScoreHolder`, `ScoreHolder<SimpleBigDecimalScore>`

      public final class SimpleBigDecimalScoreHolderImpl
      extends AbstractScoreHolder<SimpleBigDecimalScore>
      implements SimpleBigDecimalScoreHolder

  See Also:
    `SimpleBigDecimalScore`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `AbstractScoreHolder.ConstraintActivationUnMatchListener`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected Map<org.kie.api.definition.rule.Rule,​BiConsumer<org.kie.api.runtime.rule.RuleContext,​BigDecimal>>` | `matchExecutorByNumberMap` |
    `protected BigDecimal` | `score` |

    - ### Fields inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `constraintMatchEnabled, constraintMatchTotalMap, indictmentMap, zeroScore`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SimpleBigDecimalScoreHolderImpl​(boolean constraintMatchEnabled)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weight)` |
    `void` | `configureConstraintWeight​(org.kie.api.definition.rule.Rule rule, SimpleBigDecimalScore constraintWeight)` |
    `SimpleBigDecimalScore` | `extractScore​(int initScore)` |
    `BigDecimal` | `getScore()` |
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, long weightMultiplier)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier)` | For internal use only, use penalize() or reward() instead.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext)` | Penalize a match by the `ConstraintWeight` negated.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext)` | Reward a match by the `ConstraintWeight`.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.

    - ### Methods inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `extractJustificationList, getConstraintMatchTotalMap, getIndictmentMap, isConstraintMatchEnabled, registerConstraintMatch, setJustificationListConverter`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### matchExecutorByNumberMap

          protected final Map<org.kie.api.definition.rule.Rule,​BiConsumer<org.kie.api.runtime.rule.RuleContext,​BigDecimal>> matchExecutorByNumberMap

    - #### score

          protected BigDecimal score

  - ### Constructor Detail

    - #### SimpleBigDecimalScoreHolderImpl

          public SimpleBigDecimalScoreHolderImpl​(boolean constraintMatchEnabled)

  - ### Method Detail

    - #### getScore

          public BigDecimal getScore()

    - #### configureConstraintWeight

          public void configureConstraintWeight​(org.kie.api.definition.rule.Rule rule,
                                                SimpleBigDecimalScore constraintWeight)

      Overrides:
        `configureConstraintWeight` in class `AbstractScoreHolder<SimpleBigDecimalScore>`

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from interface: `ScoreHolder`
      Penalize a match by the `ConstraintWeight` negated.
      Specified by:
        `penalize` in interface `ScoreHolder<SimpleBigDecimalScore>`
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                               BigDecimal weightMultiplier)

      Description copied from interface: `SimpleBigDecimalScoreHolder`
      Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
      Specified by:
        `penalize` in interface `SimpleBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from interface: `ScoreHolder`
      Reward a match by the `ConstraintWeight`.
      Specified by:
        `reward` in interface `ScoreHolder<SimpleBigDecimalScore>`
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                             BigDecimal weightMultiplier)

      Description copied from interface: `SimpleBigDecimalScoreHolder`
      Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
      Specified by:
        `reward` in interface `SimpleBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Overrides:
        `impactScore` in class `AbstractScoreHolder<SimpleBigDecimalScore>`
      Parameters:
        `kcontext` - never null

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  int weightMultiplier)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<SimpleBigDecimalScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  long weightMultiplier)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<SimpleBigDecimalScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  BigDecimal weightMultiplier)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in interface `SimpleBigDecimalScoreHolder`
      Specified by:
        `impactScore` in class `AbstractScoreHolder<SimpleBigDecimalScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any

    - #### addConstraintMatch

          public void addConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                         BigDecimal weight)

      Specified by:
        `addConstraintMatch` in interface `SimpleBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weight` - never null, higher is better, negative for a penalty, positive for a reward

    - #### extractScore

          public SimpleBigDecimalScore extractScore​(int initScore)

      Specified by:
        `extractScore` in class `AbstractScoreHolder<SimpleBigDecimalScore>`